Index: trunk/LMDZ.GENERIC/libf/phystd/initracer.F
===================================================================
--- trunk/LMDZ.GENERIC/libf/phystd/initracer.F	(revision 2541)
+++ trunk/LMDZ.GENERIC/libf/phystd/initracer.F	(revision 2542)
@@ -65,12 +65,12 @@
                ! Temporary not implemented solution
                if (nqtot/=nq) then
-                 call abort_physic('initracer','Different number of&
-     & tracers in dynamics and physics not managed yet',1)
+                 call abort_physic('initracer','Different number of '//
+     & 'tracers in dynamics and physics not managed yet',1)
                endif
                EXIT
              ENDIF
            ELSE ! If pb, or if reached EOF without having found nqtot
-             call abort_physic('initracer','Unable to read numbers&
-     & of tracers in traceur.def',1)
+             call abort_physic('initracer','Unable to read numbers '//
+     & 'of tracers in traceur.def',1)
            ENDIF
          ENDDO
@@ -83,4 +83,6 @@
        IF (.NOT.ALLOCATED(noms))         ALLOCATE(noms(nq))
        IF (.NOT.ALLOCATED(mmol))         ALLOCATE(mmol(nq))
+       IF (.NOT.ALLOCATED(aki))          ALLOCATE(aki(nqtot))
+       IF (.NOT.ALLOCATED(cpi))          ALLOCATE(cpi(nqtot))
        IF (.NOT.ALLOCATED(radius))       ALLOCATE(radius(nq))
        IF (.NOT.ALLOCATED(rho_q))        ALLOCATE(rho_q(nq))
@@ -90,7 +92,12 @@
        IF (.NOT.ALLOCATED(qextrhor))     ALLOCATE(qextrhor(nq))
        IF (.NOT.ALLOCATED(igcm_dustbin)) ALLOCATE(igcm_dustbin(nq))
+       IF (.NOT.ALLOCATED(is_chim))      ALLOCATE(is_chim(nqtot))
        !! initialization
-       alpha_lift(:)=0.
-       alpha_devil(:)=0.
+       alpha_lift(:)  = 0.
+       alpha_devil(:) = 0.
+       mmol(:)        = 0.
+       aki(:)         = 0.
+       cpi(:)         = 0.
+       is_chim(:)     = 0
        
        ! Added by JVO 2017 : these arrays are handled later
@@ -382,4 +389,8 @@
       close(407)
 
+      ! Calculate number of species in the chemistry
+      nesp = sum(is_chim)
+      write(*,*) 'Number of species in the chemistry nesp = ',nesp
+
 c------------------------------------------------------------
 c     Initialisation tracers ....
@@ -469,4 +480,5 @@
           ! JVO 20 : We should add a sanity check aborting when duplicates in names !
           write(*,*)"initracer: iq=",iq,"noms(iq)=",trim(noms(iq))
+          ! option mmol
           if (index(tracline,'mmol='   ) /= 0) then
               read(tracline(index(tracline,'mmol=')+len('mmol='):),*)
@@ -478,4 +490,34 @@
      $             mmol(iq)
           end if
+          ! option aki 
+          if (index(tracline,'aki='   ) /= 0) then
+              read(tracline(index(tracline,'aki=')+len('aki='):),*)
+     $             aki(iq)
+              write(*,*) ' Parameter value (traceur.def) : aki=',
+     $             aki(iq)
+          else
+              write(*,*) ' Parameter value (default)     : aki=',
+     $             aki(iq)
+          end if
+          ! option cpi 
+          if (index(tracline,'cpi='   ) /= 0) then
+              read(tracline(index(tracline,'cpi=')+len('cpi='):),*)
+     $             cpi(iq)
+              write(*,*) ' Parameter value (traceur.def) : cpi=',
+     $             cpi(iq)
+          else
+              write(*,*) ' Parameter value (default)     : cpi=',
+     $             cpi(iq)
+          end if
+          ! option is_chim 
+          if (index(tracline,'is_chim='   ) /= 0) then
+          read(tracline(index(tracline,'is_chim=')+len('is_chim='):),*)
+     $             is_chim(iq)
+              write(*,*) ' Parameter value (traceur.def) : is_chim=',
+     $             is_chim(iq)
+          else
+              write(*,*) ' Parameter value (default)     : is_chim=',
+     $             is_chim(iq)
+          end if
       end subroutine get_tracdat
 
Index: trunk/LMDZ.GENERIC/libf/phystd/physiq_mod.F90
===================================================================
--- trunk/LMDZ.GENERIC/libf/phystd/physiq_mod.F90	(revision 2541)
+++ trunk/LMDZ.GENERIC/libf/phystd/physiq_mod.F90	(revision 2542)
@@ -31,5 +31,5 @@
                           alpha_lift, alpha_devil, qextrhor, &
                           igcm_h2o_ice, igcm_h2o_vap, igcm_dustbin, &
-                          igcm_co2_ice
+                          igcm_co2_ice, nesp, is_chim
       use time_phylmdz_mod, only: ecritphy, iphysiq, nday
       use phyetat0_mod, only: phyetat0
@@ -258,5 +258,5 @@
       real omega(ngrid,nlayer)            ! omega velocity (Pa/s, >0 when downward)
 
-      integer l,ig,ierr,iq,nw,isoil
+      integer l,ig,ierr,iq,nw,isoil,iesp
       
       real zls                       ! Solar longitude (radians).
@@ -300,4 +300,5 @@
       real dt_ekman(ngrid,noceanmx), dt_hdiff(ngrid,noceanmx) ! Slab_ocean routine.
       real zdtsw1(ngrid,nlayer), zdtlw1(ngrid,nlayer)         ! Callcorrk routine.
+      real zdtchim(ngrid,nlayer)                              ! Calchim routine.
                               
       ! For Surface Tracers : (kg/m2/s)
@@ -323,6 +324,6 @@
       real dqvaplscale(ngrid,nlayer)  ! Largescale routine.
       real dqcldlscale(ngrid,nlayer)  ! Largescale routine.
-      REAL zdqchim(ngrid,nlayer,nq)   ! Calchim_asis routine
-      REAL zdqschim(ngrid,nq)         ! Calchim_asis routine
+      REAL,allocatable,save :: zdqchim(:,:,:) ! Calchim_asis routine
+      REAL,allocatable,save :: zdqschim(:,:)  ! Calchim_asis routine
 
       REAL array_zero1(ngrid)
@@ -476,4 +477,6 @@
             if(photochem) then
               call ini_conc_mod(ngrid,nlayer)
+              IF (.NOT.ALLOCATED(zdqchim))  ALLOCATE(zdqchim(ngrid,nlayer,nesp))
+              IF (.NOT.ALLOCATED(zdqschim)) ALLOCATE(zdqschim(ngrid,nesp))
             endif
          endif
@@ -1487,14 +1490,19 @@
                         fract,zzlev,zzlay,zday,pq,pdq,zdqchim,zdqschim, &
                         array_zero1,array_zero1,                        &
-                        pu,pdu,pv,pdv,array_zero2,array_zero2)
+                        pu,pdu,pv,pdv,array_zero2,array_zero2,icount,zdtchim)
 
            ! increment values of tracers:
-           DO iq=1,nq ! loop on all tracers; tendencies for non-chemistry
-                      ! tracers is zero anyways
-             DO l=1,nlayer
-               DO ig=1,ngrid
-                 pdq(ig,l,iq)=pdq(ig,l,iq)+zdqchim(ig,l,iq)
+           iesp = 0
+           DO iq=1,nq   ! loop on all tracers; tendencies for non-chemistry
+                        ! tracers is zero anyways
+                        ! September 2020: flag is_chim to increment only on chemical species
+             IF (is_chim(iq)==1) THEN
+               iesp = iesp + 1
+               DO l=1,nlayer
+                 DO ig=1,ngrid
+                   pdq(ig,l,iq)=pdq(ig,l,iq)+zdqchim(ig,l,iesp)
+                 ENDDO
                ENDDO
-             ENDDO
+             ENDIF
            ENDDO ! of DO iq=1,nq
 
@@ -1507,4 +1515,7 @@
              ENDDO
            ENDDO ! of DO iq=1,nq
+
+           ! increment values of temperature:
+           pdt(1:ngrid,1:nlayer)=pdt(1:ngrid,1:nlayer)+zdtchim(1:ngrid,1:nlayer)
 
          END IF  ! of IF (photochem)
Index: trunk/LMDZ.GENERIC/libf/phystd/tracer_h.F90
===================================================================
--- trunk/LMDZ.GENERIC/libf/phystd/tracer_h.F90	(revision 2541)
+++ trunk/LMDZ.GENERIC/libf/phystd/tracer_h.F90	(revision 2542)
@@ -5,5 +5,6 @@
 
        integer, save :: nqtot ! total number of tracers
-!$OMP THREADPRIVATE(nqtot)
+       integer, save :: nesp  ! number of species in the chemistry
+!$OMP THREADPRIVATE(nqtot,nesp)
 
        logical :: moderntracdef=.false. ! Standard or modern traceur.def
@@ -12,4 +13,6 @@
        character*30, save, allocatable :: noms(:)   ! name of the tracer
        real, save, allocatable :: mmol(:)     ! mole mass of tracer (g/mol-1) 
+       real, save, allocatable :: aki(:)      ! to compute coefficient of thermal concduction if photochem
+       real, save, allocatable :: cpi(:)      ! to compute cpnew in concentration.F if photochem
        real, save, allocatable :: radius(:)   ! dust and ice particle radius (m)
        real, save, allocatable :: rho_q(:)    ! tracer densities (kg.m-3)
@@ -25,6 +28,9 @@
        real,save :: rho_co2     ! CO2 ice density (kg.m-3)
        real,save :: ref_r0        ! for computing reff=ref_r0*r0 (in log.n. distribution)
-!$OMP THREADPRIVATE(noms,mmol,radius,rho_q,qext,alpha_lift,alpha_devil,qextrhor, &
+!$OMP THREADPRIVATE(noms,mmol,aki,cpi,radius,rho_q,qext,alpha_lift,alpha_devil,qextrhor, &
 	!$OMP varian,r3n_q,rho_dust,rho_ice,rho_co2,ref_r0)
+
+       integer, save, allocatable :: is_chim(:) ! 1 if tracer used in chemistry, else 0
+!$OMP THREADPRIVATE(is_chim)
 
 ! tracer indexes: these are initialized in initracer and should be 0 if the
